package org.jboss.envers.test.integration.components;

/**
 * @author Adam Warski (adam at warski dot org)
 */
public class Component1 {
    private String str1;

    private String str2;

    public Component1(String str1, String str2) {
        this.str1 = str1;
        this.str2 = str2;
    }

    public Component1() {
    }

    public String getStr2() {
        return str2;
    }

    public void setStr2(String str2) {
        this.str2 = str2;
    }

    public String getStr1() {
        return str1;
    }

    public void setStr1(String str1) {
        this.str1 = str1;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Component1)) return false;

        Component1 that = (Component1) o;

        if (str1 != null ? !str1.equals(that.str1) : that.str1 != null) return false;
        if (str2 != null ? !str2.equals(that.str2) : that.str2 != null) return false;

        return true;
    }

    public int hashCode() {
        int result;
        result = (str1 != null ? str1.hashCode() : 0);
        result = 31 * result + (str2 != null ? str2.hashCode() : 0);
        return result;
    }
}
